#!/usr/bin/perl -w
use strict;

sub help{
        if(grep {$_ eq "-h"} @ARGV){
		        print " ############################################################################################\n\n";
				print " This script can be used to filter out the scaffolds whose length are less than length_cutoff\n";
				print " usage: perl scaffold_length_filter.pl scaffold.fasta length_cutoff > scaffold_filtered.fasta\n\n";
		        print " ############################################################################################\n\n";
			    }
		}

&help();




(my $fasta, my $length_cutoff)=@ARGV;
my %fasta_hash;
&file2hash($fasta);


foreach (sort keys%fasta_hash){
	my $length=length($fasta_hash{$_});
	if ($length > ($length_cutoff-1)){
		print "$_\n$fasta_hash{$_}\n";
		}
	}



sub file2hash{
	(my $file)=@_;
	open IN, $file;
	my $key;
	while(<IN>){
		chomp($_);
		if (/>/){
			$key=$_;
		}else {
			if (!exists $fasta_hash{$key}){
				$fasta_hash{$key}=$_;
			}else {
				$fasta_hash{$key}.=$_;
			}
		}
	}
	close IN;
}


